VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.1#0"; "COMDLG32.OCX"
Begin VB.Form frmSecret 
   BackColor       =   &H00C0C0C0&
   Caption         =   " -  "
   ClientHeight    =   1920
   ClientLeft      =   1770
   ClientTop       =   3645
   ClientWidth     =   5820
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   204
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "Secret.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   1920
   ScaleWidth      =   5820
   Begin VB.CommandButton cmdView 
      Caption         =   "&"
      Height          =   400
      Left            =   1620
      TabIndex        =   4
      Top             =   1020
      Width           =   1200
   End
   Begin VB.CommandButton cmdDecipher 
      Caption         =   "&"
      Enabled         =   0   'False
      Height          =   400
      Left            =   4320
      TabIndex        =   3
      Top             =   1020
      Width           =   1200
   End
   Begin VB.CommandButton cmdEncipher 
      Caption         =   "&"
      Enabled         =   0   'False
      Height          =   400
      Left            =   2940
      TabIndex        =   2
      Top             =   1020
      Width           =   1200
   End
   Begin VB.TextBox txtFile 
      Height          =   285
      Left            =   300
      TabIndex        =   1
      Text            =   "txtFile"
      Top             =   480
      Width           =   5175
   End
   Begin VB.CommandButton cmdBrowse 
      Caption         =   "&..."
      Height          =   400
      Left            =   300
      TabIndex        =   0
      Top             =   1020
      Width           =   1200
   End
   Begin MSComDlg.CommonDialog cdlOne 
      Left            =   60
      Top             =   1500
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   327680
   End
   Begin VB.Label lblFile 
      Caption         =   ":"
      Height          =   195
      Left            =   300
      TabIndex        =   5
      Top             =   240
      Width           =   1755
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&"
      Begin VB.Menu mnuOpen 
         Caption         =   "&..."
      End
      Begin VB.Menu mnuEnc 
         Caption         =   "&"
      End
      Begin VB.Menu mnuDenc 
         Caption         =   "&"
      End
      Begin VB.Menu mnuFileDash1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "&"
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&"
      Begin VB.Menu mnuContents 
         Caption         =   "&"
         HelpContextID   =   101
      End
      Begin VB.Menu mnuHelpDash1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuAbout 
         Caption         =   "& ..."
      End
   End
End
Attribute VB_Name = "frmSecret"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
DefLng A-Z


Private Sub cmdBrowse_Click()
    'Prompt user for filename
    cdlOne.DialogTitle = ""
    cdlOne.Flags = cdlOFNHideReadOnly
    cdlOne.Filter = "All files (*.*)|*.*"
    cdlOne.CancelError = True
    On Error Resume Next
    cdlOne.ShowOpen
    'Grab filename
    If Err = 0 Then
        txtFile.Text = cdlOne.filename
    End If
    On Error GoTo 0
End Sub

Private Sub cmdDecipher_Click()
    'Check password
    frmPassword.Show vbModal
    If Password$ = "" Then Exit Sub
    'Decipher file if password is valid
    If InStr(Head$, Hash$(Password$)) = 9 Then
        MousePointer = vbHourglass
        cmdEncipher.Enabled = False
        cmdDecipher.Enabled = False
        cmdView.Enabled = False
        cmdBrowse.Enabled = False
        Refresh
        Decipher
        txtFile_Change
        cmdBrowse.Enabled = True
        MousePointer = vbDefault
    Else
        MsgBox " -  .", 48, ""
    End If
End Sub

Private Sub cmdEncipher_Click()
    'Check password
    frmPassword.Show vbModal
    'Encipher file
    If Password$ = "" Then Exit Sub
    MousePointer = vbHourglass
    cmdEncipher.Enabled = False
    cmdDecipher.Enabled = False
    cmdView.Enabled = False
    cmdBrowse.Enabled = False
    Refresh
    Encipher
    txtFile_Change
    cmdBrowse.Enabled = True
    MousePointer = vbDefault
End Sub

Private Sub cmdView_Click()
    Dim A$
    Dim i, ndx
    MousePointer = vbHourglass
    'Get file contents
    Open txtFile.Text For Binary As #1
    A$ = Space$(LOF(1))
    Get #1, , A$
    Close #1
    Do
        ndx = InStr(A$, Chr$(0))
        If ndx = 0 Or ndx > 5000 Then Exit Do
        Mid$(A$, ndx, 1) = Chr$(1)
    Loop
    'Display file contents
    MousePointer = vbDefault
    frmView.rtfView.Text = A$
    frmView.Caption = " - " & txtFile.Text
    frmView.Show vbModal
End Sub

Private Sub Form_Load()
    'Center this form
    Left = (Screen.Width - Width) \ 2
    Top = (Screen.Height - Height) \ 2
    'Disable most command buttons
    cmdEncipher.Enabled = False
    cmdDecipher.Enabled = False
    cmdView.Enabled = False
    'Initialize filename field
    txtFile.Text = ""
End Sub



Private Sub Form_Unload(Cancel As Integer)
  frmOptions.Show
End Sub

Private Sub mnuAbout_Click()
  About.Show 1
End Sub

Private Sub mnuContents_Click()
  frmHelp.Show 1
End Sub

Private Sub mnuDenc_Click()
  cmdDecipher_Click
End Sub

Private Sub mnuEnc_Click()
  cmdEncipher_Click
End Sub

Private Sub mnuExit_Click()
    Unload Me
End Sub

Private Sub mnuFile_Click()
  mnuOpen.Enabled = cmdBrowse.Enabled
  mnuEnc.Enabled = cmdEncipher.Enabled
  mnuDenc.Enabled = cmdDecipher.Enabled
End Sub

Private Sub mnuOpen_Click()
  cmdBrowse_Click
End Sub

Private Sub txtFile_Change()
    Dim FileLen
    'Check to see whether file exists
    On Error Resume Next
    FileLen = Len(Dir$(txtFile.Text))
    'Disable buttons if filename isn't valid
    If Err <> 0 Or FileLen = 0 Or Len(txtFile.Text) = 0 Then
        cmdEncipher.Enabled = False
        cmdDecipher.Enabled = False
        cmdView.Enabled = False
        Exit Sub
    End If
    'Get first 16 bytes of selected file
    Open txtFile.Text For Binary As #1
    Head$ = Space$(16)
    Get #1, , Head$
    Close #1
    'Check to see whether file is already enciphered
    If InStr(Head$, "[Secret]") = 1 Then
        cmdEncipher.Enabled = False
        cmdDecipher.Enabled = True
    Else
        cmdEncipher.Enabled = True
        cmdDecipher.Enabled = False
    End If
    cmdView.Enabled = True
End Sub

Sub Encipher()
    Open txtFile.Text For Binary As #1
    Dim A$, H$
    'Load entire file into A$
    A$ = Space$(LOF(1))
    Get #1, , A$
    'Prepare header string
    H$ = "[Secret]" & Hash$(Password$) & vbCrLf
    'Do the actual encryption
    Process A$
    'Write header
    Put #1, 1, H$
    'Write enciphered data
    Put #1, , A$
    Close #1
End Sub

Sub Decipher()
    Open txtFile.Text For Binary As #1
    Dim A$, H$
    'Get header (first 18 bytes of enciphered file)
    H$ = Space$(18)
    'Get file contents (all remaining bytes in file)
    A$ = Space$(LOF(1) - 18)
    'Load header bytes
    Get #1, , H$
    'Load all the rest
    Get #1, , A$
    Close #1
    'Decipher file contents
    Process A$
    'Replace file with deciphered version
    Kill txtFile.Text
    Open txtFile.Text For Binary As #1
    Put #1, , A$
    Close #1
End Sub

Sub Process(A$)
    Dim n1, n2, n3
    Dim i
    'Form control numbers from password
    For i = 1 To Len(Password$)
        n1 = n1 + Asc(Mid$(Password$, i, 1))
        n1 = (n1 * 367 + 331) Mod &HFFF
        n2 = ((n2 + n1) * 743 + 599) Mod &HFFF
        n3 = ((n3 + n2) * 563 + 787) Mod &HFFF
    Next i
    'Do the XOR cipher
    Cipher A$, n1, n2, n3
End Sub
